#include <a_samp>

#define MAX_STRING 255
#define MAX_NAME 40

#define COLOR_GREEN 0x33AA33AA
#define COLOR_LIGHTGREEN 0x9ACD32AA
#define COLOR_RED 0xAA3333AA
#define COLOR_LIGHTRED 0xFF6347AA
#define COLOR_YELLOW 0xFFFF00AA
#define COLOR_WHITE 0xFFFFFFAA
#define COLOR_BLUE 0x33AAFFAA

forward LoadDB(playerid);
forward SaveDB(playerid);

enum pInfo
{
	Name[40],
	Password[128],
	Date,
	Level,
	Money,
	Kills,
	Deaths,
	SkinModel,
	Admin,
}

new Player[MAX_PLAYERS][pInfo];
new Warned[MAX_PLAYERS];
new PlayerAccount[MAX_PLAYERS];
new Mode_Account_db[MAX_STRING] = "Mode/Accounts/";
new PlayerLogged[MAX_PLAYERS];

public OnFilterScriptInit()
{
	print(" Register System by GhostTT");
	return 1;
}

public OnPlayerConnect(playerid)
{
	new pname[40],str[256];
	GetPlayerName(playerid,pname,sizeof(pname));
	format(str,sizeof(str),"%s%s.txt",Mode_Account_db,pname);
	if(!fexist(str))
	{
	    PlayerAccount[playerid] = 0;
	}
	else
	{
	    PlayerAccount[playerid] = 1;
	}
	return 1;
}

public OnPlayerDisconnect(playerid, reason)
{
   	Warned[playerid] = 0;
	SaveDB(playerid);
	PlayerAccount[playerid] = 0;
	return 1;
}

public OnPlayerSpawn(playerid)
{
	new loginmsg[256+1],pname[40];
	GetPlayerName(playerid,pname,40);
	if(PlayerAccount[playerid] == 0)
	{
		format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease register:",pname);
        ShowPlayerDialog(playerid,4,DIALOG_STYLE_INPUT,"Password:",loginmsg,"Register","Cancel");
	}
	else
	{
		format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease enter your password below:",pname);
		ShowPlayerDialog(playerid,5,DIALOG_STYLE_INPUT,"Login to SA-MP",loginmsg,"Login","Cancel");
	}
	return 1;
}

public OnPlayerDeath(playerid, killerid, reason)
{
    Player[playerid][Deaths]++;
	if(killerid != INVALID_PLAYER_ID)
	{
	    Player[killerid][Kills]++;
	    GivePlayerMoney(killerid,1500);
	    SendDeathMessage(killerid,playerid,reason);
	}
	else
	{
	    SendDeathMessage(INVALID_PLAYER_ID,playerid,reason);
	}
	return 1;
}

public OnDialogResponse(playerid, dialogid, response, listitem, inputtext[])
{
    if(dialogid == 1)
	{
        if(response)
		{
		    if(listitem == 0)
		    {
                ShowPlayerDialog(playerid,2,DIALOG_STYLE_LIST,"Select the command:","Pistols\nShotguns\nMicro SMG's\nAssault\n","Select","Cancel");
		    }
		    if(listitem == 1)
		    {
				SetPlayerScore(playerid,GetPlayerScore(playerid)+1);
		    }
		    if(listitem == 2)
		    {
		        GivePlayerMoney(playerid,100000);
		    }
		    if(listitem == 3)
		    {
		        ShowPlayerDialog(playerid,3,DIALOG_STYLE_LIST,"Select the car:","NRG-500\nSultan\nMaverick\nS.W.A.T.\n","Select","Cancel");
		    }
		    if(listitem == 4)
		    {
				new weapons[11] = { 26, 24, 28, 30, 31, 32, 34, 35, 38, 37, 16 };
		        new rand = random(11);
		        GivePlayerWeapon(playerid,weapons[rand],500);
		    }
		}
		else
		{
		}
	}
	if(dialogid == 2)
	{
        if(response)
		{
		    if(listitem == 0)
		    {
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL_SILENCED,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_DESERT_EAGLE,200);
		    }
		    if(listitem == 1)
		    {
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_SHOTGUN,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_SAWNOFF_SHOTGUN,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_SPAS12_SHOTGUN,200);
			}
			if(listitem == 2)
		    {
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_MICRO_UZI,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_MP5,200);
			}
			if(listitem == 3)
			{
			    SetPlayerSkillLevel(playerid,WEAPONSKILL_AK47,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_M4,200);
		        SetPlayerSkillLevel(playerid,WEAPONSKILL_SNIPERRIFLE,200);
			}
	    }
	    else
	    {
	        ShowPlayerDialog(playerid,1,DIALOG_STYLE_LIST,"Select the bonus:","WeaponSkill\nLevel\nMoney\nCar\nWeapon\n","Select","Cancel");
	    }
	}
	if(dialogid == 3)
	{
	    if(response)
	    {
	        new Float:X, Float:Y, Float:Z;
			new created_vehicle_id;
			GetPlayerPos(playerid,X,Y,Z);
			if(listitem == 0)
			{
			    created_vehicle_id = CreateVehicle(522,X,Y,Z,0,0,0,-1);
			    PutPlayerInVehicle(playerid,created_vehicle_id,0);
			}
			if(listitem == 1)
			{
			    created_vehicle_id = CreateVehicle(560,X,Y,Z,0,0,0,-1);
			    PutPlayerInVehicle(playerid,created_vehicle_id,0);
			}
			if(listitem == 2)
			{
			    created_vehicle_id = CreateVehicle(487,X,Y,Z,0,0,0,-1);
			    PutPlayerInVehicle(playerid,created_vehicle_id,0);
			}
			if(listitem == 3)
			{
			    created_vehicle_id = CreateVehicle(601,X,Y,Z,0,0,0,-1);
			    PutPlayerInVehicle(playerid,created_vehicle_id,0);
			}
			SendClientMessage(playerid,0xFF6347AA,"Xpa: take your vehicle");
	    }
	    else
	    {
	        ShowPlayerDialog(playerid,1,DIALOG_STYLE_LIST,"Select the bonus:","WeaponSkill\nLevel\nMoney\nCar\nWeapon\n","Select","Cancel");
	    }
	}
	if(dialogid == 4)
	{
	    if(response)
	    {
	        if(!strval(inputtext))
	        {
	            new loginmsg[256+1];
		        format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease register:",oGetPlayerName(playerid));
	            return ShowPlayerDialog(playerid,4,DIALOG_STYLE_INPUT,"Password:",loginmsg,"Register","Cancel");
	        }
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL_SILENCED,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_DESERT_EAGLE,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_SHOTGUN,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_SAWNOFF_SHOTGUN,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_SPAS12_SHOTGUN,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_MICRO_UZI,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_MP5,0);
		    SetPlayerSkillLevel(playerid,WEAPONSKILL_AK47,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_M4,0);
	        SetPlayerSkillLevel(playerid,WEAPONSKILL_SNIPERRIFLE,0);
            new password[16],var[32],date[256],hour,minute,second,year,month,day,pname[40],filename[256];
			strmid(password,inputtext,0,strlen(inputtext));
			GetPlayerName(playerid,pname,sizeof(pname));
			format(filename,sizeof(filename),"%s%s.txt",Mode_Account_db,pname);
			gettime(hour,minute,second);
			getdate(year,month,day);
			if(minute < 10) format(date,sizeof(date),"%d.%d.%d, %d:0%d",day,month,year,hour,minute);
			else format(date,sizeof(date),"%d.%d.%d, %d:%d",day,month,year,hour,minute);
	        format(filename,sizeof(filename),"%s%s.txt",Mode_Account_db,pname);
			new File:file = fopen(filename,io_append);
			Player[playerid][Level] = GetPlayerScore(playerid);
			Player[playerid][Money] = GetPlayerMoney(playerid);
			Player[playerid][SkinModel] = GetPlayerSkin(playerid);
			set(Player[playerid][Password],password);
	        format(var,32,"Password=%s\r\n",Player[playerid][Password]);fwrite(file,var);
	        format(var,32,"Register_Date=%s\r\n",date);fwrite(file,var);
	        format(var,32,"Level=%d\r\n",Player[playerid][Level]);fwrite(file,var);
	        format(var,32,"Money=%d\r\n",Player[playerid][Money]);fwrite(file,var);
	        format(var,32,"Kills=%d\r\n",Player[playerid][Kills]);fwrite(file,var);
	        format(var,32,"Deaths=%d\r\n",Player[playerid][Deaths]);fwrite(file,var);
	        format(var,32,"SkinModel=%d\r\n",Player[playerid][SkinModel]);fwrite(file,var);
	        format(var,32,"Status=%d\r\n",Player[playerid][Admin]);fwrite(file,var);
			fclose(file);

		    new loginmsg[256+1];
			format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease enter your password below:",pname);
			ShowPlayerDialog(playerid,5,DIALOG_STYLE_INPUT,"Login to SA-MP",loginmsg,"Login","Cancel");
	    }
	    else
	    {
	        new loginmsg[256+1];
	        format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease register:",oGetPlayerName(playerid));
        	ShowPlayerDialog(playerid,4,DIALOG_STYLE_INPUT,"Password:",loginmsg,"Register","Cancel");
	    }
	}
	if(dialogid == 5)
	{
	    if(response)
		{
		    new pname[40],filename[256],string[256];
            GetPlayerName(playerid,pname,sizeof(pname));
		    format(filename,sizeof(filename),"%s%s.txt",Mode_Account_db,pname);
			new key[128],Data[128];
		    new File:file = fopen(filename,io_read);
			while(fread(file,Data,sizeof(Data)))
			{
				key = ini_GetKey(Data);
			    strmid(Player[playerid][Password],ini_GetValue(Data),0,strlen(ini_GetValue(Data)));
			}
	        if(strcmp(Player[playerid][Password],inputtext,false,strlen(Player[playerid][Password])) == 0)
	        {
				LoadDB(playerid);
				format(string,sizeof(string),"C  %s!     ",oGetPlayerName(playerid));
				SendClientMessage(playerid,COLOR_GREEN,string);
	        }
	        else
        	{
				if(Warned[playerid] != 1)
        		{
					Warned[playerid]++;
					SendClientMessage(playerid,COLOR_RED," !      ");
				    new loginmsg[256+1];
					format(loginmsg,256,"Welcome to the server.\n\nAccount: %s\n\nPlease enter your password below:",pname);
					ShowPlayerDialog(playerid,1,DIALOG_STYLE_INPUT,"Login to SA-MP",loginmsg,"Login","Cancel");
				}
				else
				{
				    Kick(playerid);
				}
        	}
		}
		else
		{
            SendClientMessage(playerid,0xFFFFFFFF,"You are not logged");
        }
	}
	return 1;
}

public LoadDB(playerid)
{
	new filename[256],string[256];
    format(filename,sizeof(filename),"%s%s.txt",Mode_Account_db,oGetPlayerName(playerid));
    new File:file = fopen(filename,io_read);
    new key[128],Data[128];
 	while(fread(file,Data,sizeof(Data)))
	{
		key = ini_GetKey(Data);
		if(strcmp(key,"Password",true) == 0) { set(Player[playerid][Password],ini_GetValue(Data)); }
        if(strcmp(key,"Register_Date",true) == 0) { Player[playerid][Date] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"Level",true) == 0) { Player[playerid][Level] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"Money",true) == 0) { Player[playerid][Money] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"Kills",true) == 0) { Player[playerid][Kills] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"Deaths",true) == 0) { Player[playerid][Deaths] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"SkinModel",true) == 0) { Player[playerid][SkinModel] = strval(ini_GetValue(Data)); }
        if(strcmp(key,"Status",true) == 0) { Player[playerid][Admin] = strval(ini_GetValue(Data)); }
	}
    SetPlayerScore(playerid,Player[playerid][Level]);
    SetPlayerMoney(playerid,Player[playerid][Money]);
    PlayerLogged[playerid] = 1;
	format(string,sizeof(string),"%s   ",oGetPlayerName(playerid));
	SendClientMessageToAll(COLOR_WHITE,string);
	return 1;
}

public SaveDB(playerid)
{
	if(PlayerLogged[playerid] == 0)
	{
	    return 1;
	}
    new var[32],filename[256],File:file;
    format(filename,sizeof(filename),"%s%s.txt",Mode_Account_db,oGetPlayerName(playerid));
    file = fopen(filename,io_read);
    Player[playerid][Money] = GetPlayerMoney(playerid);
    Player[playerid][Level] = GetPlayerScore(playerid);
    Player[playerid][SkinModel] = GetPlayerSkin(playerid);
	format(var,32,"Password=%s\r\n",Player[playerid][Password]);fwrite(file,var);
    format(var,32,"Register_Date=%s\r\n",Player[playerid][Date]);fwrite(file,var);
    format(var,32,"Level=%d\r\n",Player[playerid][Level]);fwrite(file,var);
    format(var,32,"Money=%d\r\n",Player[playerid][Money]);fwrite(file,var);
    format(var,32,"Kills=%d\r\n",Player[playerid][Kills]);fwrite(file,var);
    format(var,32,"Deaths=%d\r\n",Player[playerid][Deaths]);fwrite(file,var);
    format(var,32,"SkinModel=%d\r\n",Player[playerid][SkinModel]);fwrite(file,var);
    format(var,32,"Status=%d\r\n",Player[playerid][Admin]);fwrite(file,var);
    fclose(file);
    PlayerLogged[playerid] = 0;
    return 1;
}

public OnPlayerUpdate(playerid)
{
	if(PlayerLogged[playerid] == 1)
	{
		if(GetPlayerScore(playerid) > Player[playerid][Level])
		{
		    new str[256];
 			Player[playerid][Level] = GetPlayerScore(playerid);
 			ShowPlayerDialog(playerid,1,DIALOG_STYLE_LIST,"Select the bonus:","WeaponSkill\nLevel\nMoney\nCar\nWeapon\n","Select","Cancel");
 			format(str,256,"%s (ID: %d)  %d !",oGetPlayerName(playerid),playerid,Player[playerid][Level]);
 			SendClientMessageToAll(COLOR_WHITE,str);
 			SendClientMessage(playerid,COLOR_BLUE," ");
		}
	}
	return 1;
}

stock ini_GetKey( line[] )
{
	new keyRes[128];
	keyRes[0] = 0;
    if ( strfind( line , "=" , true ) == -1 ) return keyRes;
    strmid( keyRes , line , 0 , strfind( line , "=" , true ) , sizeof( keyRes) );
    return keyRes;
}

stock ini_GetValue( line[] )
{
	new valRes[128];
	valRes[0]=0;
	if ( strfind( line , "=" , true ) == -1 ) return valRes;
	strmid( valRes , line , strfind( line , "=" , true )+1 , strlen( line ) , sizeof( valRes ) );
	return valRes;
}

stock set(dest[],source[])
{
	new count = strlen(source);
  	for(new i=0;i<count;i++)
 	{
		dest[i]=source[i];
  	}
  	dest[count]=0;
}

stock oGetPlayerName(playerid)
{
	new pname[20];
	GetPlayerName(playerid,pname,sizeof(pname));
	return pname;
}

stock SetPlayerMoney(playerid,money)
{
	ResetPlayerMoney(playerid);
	GivePlayerMoney(playerid,money);
	return 1;
}
